import re

class que:

    def __init__(self):
        self.head = None
        self.tail = None
        self.length = None

    def show(self):
        el = self.head
        a = []
        while el != None:
            a.append(el.val)
            el = el.next
        return a
    
class node:

    def __init__(self, val):
        self.val = val
        self.prev = None
        self.next = None

    def add(self, li):
        if li.length == None:
            li.head = self
            li.tail = self
            li.length = 1
        else:
            self.prev = li.tail
            li.tail.next = self
            li.tail = self
            li.length += 1
        
    def push(self, li):
        if self == li.tail:
            self.prev.next = None
            li.tail = self.prev
            li.length -= 1
            return
        if self == li.head:
            self.next.prev = None
            li.head = self.next
            li.length -= 1
            return
        else:
            self.next.prev = self.prev
            self.prev.next = self.next
            li.length -= 1
            return
        
        
class read:

    def __init__(self, string):
        self.l = len(string)
        self.st = self.l/2
        self.en = self.l/2
        self.seq = string
        
        
    def get_en(self):
        return (self.seq[-(self.en):])
    
    def get_st(self):
        return (self.seq[0:self.st])

    def glue(self, x, n):
        a = min(self.st, x.en)
        i = 0
        while a+i != min(self.l, x.l):
            i += 1
            if self.seq[0:a+i] == x.seq[-(a+i):]:
                return (True, x.seq[0:-(a+i)] + self.seq)
        if n == 0:
            return(x.glue(self, 1))
        else:
            return (False, None)
            
reads = que()
temp = ''
with open('data.txt') as f:
    for line in f.readlines():
        if line[0] == '>':
            (node(read(temp))).add(reads)
            temp = ''
        else:
            temp += line.replace('\n','')
    (node(read(temp))).add(reads)

reads.head.push(reads)

contig = reads.head.val
el = reads.head.next

prev_len = 0
while reads.length != prev_len:
    prev_len = reads.length
    while el != None:
        temp = contig.glue(el.val, 0)
        if temp[0] == True:
            el.push(reads)
            reads.head.val.seq = temp[1]
        el = el.next
    el = reads.head.next

print reads.head.val.seq